theory Show_LTS
  imports 
    LTS 
    Cooperation_Program
begin

locale shows_transition = shows_formula shows_atom + T: shows_formula shows_tatom
  for shows_atom :: "('f,'v,'t) exp \<Rightarrow> shows"
  and shows_tatom :: "('f,'v trans_var,'t)exp \<Rightarrow> shows"
begin
fun shows_transition :: "('f,'v,'t,'l :: show) transition_rule \<Rightarrow> shows" where
  "shows_transition (Transition s t \<phi>) = shows s o shows '' ---> '' o shows t o shows '': '' o T.shows_formula \<phi>"

fun shows_labeled_transition :: "('tr :: show \<times> ('f,'v,'t,'l :: show) transition_rule) \<Rightarrow> shows" where
  "shows_labeled_transition (lab, tran) = shows lab o shows '': '' o shows_transition tran"

fun shows_lts :: "('f,'v,'t,'l :: show ,'tr :: show)lts_impl \<Rightarrow> shows" where
  "shows_lts (Lts_Impl I tran lc) = shows ''LTS:\<newline>Initial locations: '' o shows I o shows ''\<newline>Transitions\<newline>''
     o shows_sep shows_labeled_transition shows_nl tran o shows ''\<newline>Location conditions''
     o shows_sep (\<lambda> (l,f). shows l o shows '': '' o shows_formula f) shows_nl lc o shows_nl"

end

fun shows_cooperation_program :: "('f,'v,'t,('l :: show)sharp,'tr :: show)lts_impl \<Rightarrow> shows" where
  "shows_cooperation_program (Lts_Impl I tran lc) = (let tran' = filter (\<lambda> (t,tt). is_sharp (target tt)) tran;
     tran'' = (case partition (\<lambda> (t,tt). is_sharp (source tt)) tran' of (ss, fs) \<Rightarrow> fs @ ss)
     in shows ''Cooperation program (only sharp-part)\<newline>'' o
        shows_sep 
          (\<lambda> (t,tt). shows t o shows '': '' o shows (source tt) o shows '' --> '' o shows (target tt)) 
          shows_nl 
          tran'') o shows_nl"

declare shows_transition.shows_transition.simps[code]
declare shows_transition.shows_labeled_transition.simps[code]
declare shows_transition.shows_lts.simps[code]

end
